<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:56 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Mcts (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Mcts (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Mcts.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?towerwarspp/player/mcts/Mcts.html" target="_top">Frames</a></li>
<li><a href="Mcts.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.player.mcts</div>
<h2 title="Class Mcts" class="title">Class Mcts</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>towerwarspp.player.mcts.Mcts</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.lang.Runnable</dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">Mcts</span>
extends java.lang.Object
implements java.lang.Runnable</pre>
<div class="block">This class implements a concurrent version of the Monte Carlo tree search algorithm. In order to balance between
 exploitation and exploration the UCT (Upper Confidence Bound 1 applied to trees) is used (see wikipedia Monte Carlo
 tree search for detailed information  <a href="https://en.wikipedia.org/wiki/Monte_Carlo_tree_search">Monte Carlo
 tree search</a>.

 The main algorithm is divided into 4 steps: Selection - Expansion - Simulation - Backpropagation

 Selection: From the root we descend into the tree always choosing the Node for which the UCB1 formulae is highest.
 The algorithm descends as far as the Node he is at is expanded, meaning for all child Nodes at least one Simulation has
 been run or until hea reaches a terminal Node (representing the end of the game).

 Expansion: If a Node is reached that is not fully expanded one of the next possible game states is added as a child
 and a simulation is run for this new child. If it was the last unvisited child, the Nodes expanded status is set to
 true.

 Simulation: After expansion of a Node for the new created Node a game is played through until a terminal state.
 The playout is done depending on the set <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a>. If <a href="../../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>PlayStrategy.LIGHT</code></a> is set, the games will be
 played to the end as if both players are choosing random moves. If <a href="../../../towerwarspp/player/PlayStrategy.html#HEAVY"><code>PlayStrategy.HEAVY</code></a> is set, the games will be
 played as if both players were playing by choosing the move that has the best score returned by <a href="../../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>Board.altScore(Move, PlayerColor)</code></a>.
 <a href="../../../towerwarspp/player/PlayStrategy.html#heavyPlay-towerwarspp.board.Board-"><code>PlayStrategy.heavyPlay(Board)</code></a> is used to get this move.

 Backpropagation: After each Simulation the result of the playout is propagated up through the tree by calling the
 <a href="../../../towerwarspp/player/mcts/Node.html#backPropagateScore-double-towerwarspp.preset.PlayerColor-"><code>Node.backPropagateScore(double, PlayerColor)</code></a> method on the Node where the simulation was run.

 By concurrent it's meant that the algorithm (the select - expand - simulate - backpropagate loop) is executed all the
 time, even if it's the opponents turn. By specifying the <a href="../../../towerwarspp/player/mcts/Mcts.html#parallelizationFactor"><code>parallelizationFactor</code></a> variable during object
 construction, the maximal amount of concurrent loop iterations can be controlled. On computers that have a high number of possible
 Threads setting this variable to a value up to twice the amount of possible Threads will cause the algorithm to converge
 against optimal play a lot faster. This means, that especially for opponents that need a long time to decide on their next
 move (e.g. a human player or another ai that takes considerable time to choose a move) valuable information on the search
 tree can be gathered by continuing the main algorithm loop. When the opponent decides on one of his possible moves,
 the root of the tree is set to the Node representing this action und the resulting subtree is then used for the algorithm.
 Likewise if a move is decided on, the root of the tree is set to it's child Node representing this move.
 Through this concurrency and reuse of viable subtree the algorithm achieves better result than by building up a new
 search tree for each move request.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>13-07-17</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Robin Hundt</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#bias">bias</a></span></code>
<div class="block">Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>Node.bestUCBChild()</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#board">board</a></span></code>
<div class="block">The current board that is always at the state represented by the root of the tree.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#currentBestMove">currentBestMove</a></span></code>
<div class="block">Holds the current best move chosen dependent on the <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#debug">debug</a></span></code>
<div class="block">Reference to Debug object that is used to send debug messages.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_BIAS">DEF_BIAS</a></span></code>
<div class="block">Default Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>Node.bestUCBChild()</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>(package private) static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_SCORE">DEF_SCORE</a></span></code>
<div class="block">The default score that is backpropagated through the tree at the end of a simulation or when a terminal node is
 reached.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#endTime">endTime</a></span></code>
<div class="block">The time at which the algorithm decided on his next move.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#enemyMove">enemyMove</a></span></code>
<div class="block">Holds the last Move the enemy made.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#fairPlay">fairPlay</a></span></code>
<div class="block">If fairPlay is set to true, the algorithm will spend as much time calculating the next move as the enemy player
 took to decide on his last move.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.concurrent.Future[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#futures">futures</a></span></code>
<div class="block">Array of Futures that is used to store the Futures returned by the <code>ExecutorService.submit(Runnable)</code> method.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#newBoard">newBoard</a></span></code>
<div class="block">This variable can be set from outside this Thread.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#parallelizationFactor">parallelizationFactor</a></span></code>
<div class="block">Specifies the number of Threads that is at most used to concurrently execute <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a> instances.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#playStrategy">playStrategy</a></span></code>
<div class="block">The <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> used for this instance of the MCTS algorithm.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#root">root</a></span></code>
<div class="block">The current root of the search tree.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#startTime">startTime</a></span></code>
<div class="block">The time at which a move was requested by a call to <a href="../../../towerwarspp/player/mcts/Mcts.html#getMove--"><code>getMove()</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.ArrayDeque&lt;<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#tasks">tasks</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#timePerMove">timePerMove</a></span></code>
<div class="block">The time the algorithm will spend expanding the tree once <a href="../../../towerwarspp/player/mcts/Mcts.html#getMove--"><code>getMove()</code></a> has been called.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#treeSelectionStrategy">treeSelectionStrategy</a></span></code>
<div class="block">The  <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> used  for this instance of the MCTS algorithm.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.concurrent.ExecutorService</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#updatePool">updatePool</a></span></code>
<div class="block">ExecutorService that is used to provide parallelization of the main select - expand - simulate - backpropagate
 loop of the algorithm.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#Mcts-long-int-">Mcts</a></span>(long&nbsp;timePerMove,
    int&nbsp;parallelizationFactor)</code>
<div class="block">Construct a new Mcts object that approximately takes the specified time per move in milliseconds to decide on a move after
 one has been requested.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#Mcts-long-int-towerwarspp.player.PlayStrategy-towerwarspp.player.mcts.TreeSelectionStrategy-boolean-double-">Mcts</a></span>(long&nbsp;timePerMove,
    int&nbsp;parallelizationFactor,
    <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;playStrategy,
    <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a>&nbsp;treeSelectionStrategy,
    boolean&nbsp;fairPlay,
    double&nbsp;bias)</code>
<div class="block">Constructs a new Mcts object with the specified time per move, <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> and <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a></div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#addTask-towerwarspp.player.mcts.Task-">addTask</a></span>(<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&nbsp;task)</code>
<div class="block">Adds a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> the the task queue</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#bestMove--">bestMove</a></span>()</code>
<div class="block">This method is called if the Thread has used it's available timePerMove to decide on the final Move that should
 be played.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#checkPlayoutStrategy-double-">checkPlayoutStrategy</a></span>(double&nbsp;weight)</code>
<div class="block">Decides if to update the current <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> depending on the weight of the last played Move.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#feedEnemyMove-towerwarspp.preset.Move-">feedEnemyMove</a></span>(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</code>
<div class="block">Use to update the state of the tree after the enemy has made a move.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#freeAncestorMemory-towerwarspp.player.mcts.Node-">freeAncestorMemory</a></span>(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;node)</code>
<div class="block">Method to make a part of the search tree that is of no use anymore available to be cleared by the Garbage Collector
 by iteratively setting the parent references of all the ancestors of the passed Node to null.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#getMove--">getMove</a></span>()</code>
<div class="block">This method is always called fro outside this Thread.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#getPlayStrategy--">getPlayStrategy</a></span>()</code>
<div class="block">Returns the <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> used by the algorithm at the moment.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#getTreeSelectionStrategy--">getTreeSelectionStrategy</a></span>()</code>
<div class="block">Return the current <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> employed by the algorithm when deciding on it's next move.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#init--">init</a></span>()</code>
<div class="block">Reinitialize this Mcts object by setting the board to the new Board passed via <a href="../../../towerwarspp/player/mcts/Mcts.html#newBoard"><code>newBoard</code></a>.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#peekTask--">peekTask</a></span>()</code>
<div class="block">Returns but does not remove the Task at the head of the queue</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#pollTask--">pollTask</a></span>()</code>
<div class="block">Returns and removes a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> from the Tsk queue</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#removeTask--">removeTask</a></span>()</code>
<div class="block">Removes a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> from the task queue</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#rootPlayout--">rootPlayout</a></span>()</code>
<div class="block">This method should always be called after a new root has been set.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#run--">run</a></span>()</code>
<div class="block">Main loop of the Monte Carlo tree search.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#setInit-towerwarspp.board.Board-">setInit</a></span>(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">Method is called from other Thread.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#setPlayStrategy-towerwarspp.player.PlayStrategy-">setPlayStrategy</a></span>(<a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;playStrategy)</code>
<div class="block">Sets the <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> to the passed one.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#setTreeSelectionStrategy-towerwarspp.player.mcts.TreeSelectionStrategy-">setTreeSelectionStrategy</a></span>(<a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a>&nbsp;treeSelectionStrategy)</code>
<div class="block">Sets the passed <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> to the passed one.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#updateRoot-towerwarspp.preset.Move-">updateRoot</a></span>(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</code>
<div class="block">Used to update the <a href="../../../towerwarspp/player/mcts/Mcts.html#root"><code>root</code></a> of the tree after the enemy has made a move.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#updateRoot-towerwarspp.player.mcts.Node-">updateRoot</a></span>(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;node)</code>
<div class="block">Used to update the root of the tree after the algorithm has decided on a move to play.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Mcts.html#wakeUp--">wakeUp</a></span>()</code>
<div class="block">Wakes up the Thread that has requested a Move by calling notify().</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="DEF_BIAS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEF_BIAS</h4>
<pre>public static final&nbsp;double DEF_BIAS</pre>
<div class="block">Default Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>Node.bestUCBChild()</code></a>.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../constant-values.html#towerwarspp.player.mcts.Mcts.DEF_BIAS">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="DEF_SCORE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEF_SCORE</h4>
<pre>static final&nbsp;int DEF_SCORE</pre>
<div class="block">The default score that is backpropagated through the tree at the end of a simulation or when a terminal node is
 reached.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../constant-values.html#towerwarspp.player.mcts.Mcts.DEF_SCORE">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="debug">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>debug</h4>
<pre>private final&nbsp;<a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a> debug</pre>
<div class="block">Reference to Debug object that is used to send debug messages.</div>
</li>
</ul>
<a name="updatePool">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updatePool</h4>
<pre>private final&nbsp;java.util.concurrent.ExecutorService updatePool</pre>
<div class="block">ExecutorService that is used to provide parallelization of the main select - expand - simulate - backpropagate
 loop of the algorithm. Is used to run instance of the Runnable <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a>.</div>
</li>
</ul>
<a name="tasks">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tasks</h4>
<pre>private final&nbsp;java.util.ArrayDeque&lt;<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&gt; tasks</pre>
</li>
</ul>
<a name="bias">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bias</h4>
<pre>private&nbsp;double bias</pre>
<div class="block">Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>Node.bestUCBChild()</code></a>.</div>
</li>
</ul>
<a name="futures">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>futures</h4>
<pre>private&nbsp;java.util.concurrent.Future[] futures</pre>
<div class="block">Array of Futures that is used to store the Futures returned by the <code>ExecutorService.submit(Runnable)</code> method.</div>
</li>
</ul>
<a name="parallelizationFactor">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parallelizationFactor</h4>
<pre>private&nbsp;int parallelizationFactor</pre>
<div class="block">Specifies the number of Threads that is at most used to concurrently execute <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a> instances.</div>
</li>
</ul>
<a name="root">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>root</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a> root</pre>
<div class="block">The current root of the search tree.</div>
</li>
</ul>
<a name="board">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>board</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a> board</pre>
<div class="block">The current board that is always at the state represented by the root of the tree.</div>
</li>
</ul>
<a name="newBoard">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>newBoard</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a> newBoard</pre>
<div class="block">This variable can be set from outside this Thread. If a <a href="../../../towerwarspp/player/mcts/Task.html#INIT"><code>Task.INIT</code></a> is at the front of the queue, the main loop in
 <a href="../../../towerwarspp/player/mcts/Mcts.html#run--"><code>run()</code></a> will register the change and reinitialize the tree.</div>
</li>
</ul>
<a name="currentBestMove">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>currentBestMove</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a> currentBestMove</pre>
<div class="block">Holds the current best move chosen dependent on the <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a>. Will either contain the
 Move corresponding to the max child (highest win / games ratio) or the robust child (most games) of the root.</div>
</li>
</ul>
<a name="enemyMove">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>enemyMove</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a> enemyMove</pre>
<div class="block">Holds the last Move the enemy made.</div>
</li>
</ul>
<a name="fairPlay">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fairPlay</h4>
<pre>private&nbsp;boolean fairPlay</pre>
<div class="block">If fairPlay is set to true, the algorithm will spend as much time calculating the next move as the enemy player
 took to decide on his last move.</div>
</li>
</ul>
<a name="timePerMove">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>timePerMove</h4>
<pre>private&nbsp;long timePerMove</pre>
<div class="block">The time the algorithm will spend expanding the tree once <a href="../../../towerwarspp/player/mcts/Mcts.html#getMove--"><code>getMove()</code></a> has been called.</div>
</li>
</ul>
<a name="startTime">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>startTime</h4>
<pre>private&nbsp;long startTime</pre>
<div class="block">The time at which a move was requested by a call to <a href="../../../towerwarspp/player/mcts/Mcts.html#getMove--"><code>getMove()</code></a>.</div>
</li>
</ul>
<a name="endTime">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>endTime</h4>
<pre>private&nbsp;long endTime</pre>
<div class="block">The time at which the algorithm decided on his next move.</div>
</li>
</ul>
<a name="playStrategy">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>playStrategy</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a> playStrategy</pre>
<div class="block">The <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> used for this instance of the MCTS algorithm. If set to <a href="../../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>PlayStrategy.LIGHT</code></a> random
 games will be played in the simulation phase. If set to <a href="../../../towerwarspp/player/PlayStrategy.html#HEAVY"><code>PlayStrategy.HEAVY</code></a> the evaluation function
 provided by <a href="../../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>Board.altScore(Move, PlayerColor)</code></a> is used to carry out the simulated games.</div>
</li>
</ul>
<a name="treeSelectionStrategy">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>treeSelectionStrategy</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a> treeSelectionStrategy</pre>
<div class="block">The  <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> used  for this instance of the MCTS algorithm. If set to
 <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html#MAX"><code>TreeSelectionStrategy.MAX</code></a> upon request of a move, the move of the child  that has the highest win / games ratio
 returned by <a href="../../../towerwarspp/player/mcts/Node.html#getWeight--"><code>Node.getWeight()</code></a> will be returned.
 If set to <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html#ROBUST"><code>TreeSelectionStrategy.ROBUST</code></a> the move of the child with most played out games will be returned.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Mcts-long-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Mcts</h4>
<pre>public&nbsp;Mcts(long&nbsp;timePerMove,
            int&nbsp;parallelizationFactor)</pre>
<div class="block">Construct a new Mcts object that approximately takes the specified time per move in milliseconds to decide on a move after
 one has been requested.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>timePerMove</code> - time in milliseconds that the algorithm will spend on deciding which move to make after the request.</dd>
<dd><code>parallelizationFactor</code> - Specifies the number of Threads that is at most used to concurrently execute <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a> instances.</dd>
</dl>
</li>
</ul>
<a name="Mcts-long-int-towerwarspp.player.PlayStrategy-towerwarspp.player.mcts.TreeSelectionStrategy-boolean-double-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Mcts</h4>
<pre>public&nbsp;Mcts(long&nbsp;timePerMove,
            int&nbsp;parallelizationFactor,
            <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;playStrategy,
            <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a>&nbsp;treeSelectionStrategy,
            boolean&nbsp;fairPlay,
            double&nbsp;bias)</pre>
<div class="block">Constructs a new Mcts object with the specified time per move, <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> and <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>timePerMove</code> - time to decide on a move after a request</dd>
<dd><code>parallelizationFactor</code> - Specifies the number of Threads that is at most used to concurrently execute <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a> instances.</dd>
<dd><code>playStrategy</code> - <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> to use in the simulation phase of the algorithm.</dd>
<dd><code>treeSelectionStrategy</code> - <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> to decide on the child representing a move when a move
                              is requested.</dd>
<dd><code>fairPlay</code> - if set to true, the algorithm will spend approximately as much time deciding on it's next move,
                              as the enemy took for his last move, the passed timPerMove will only be considered at his first move
                              if the player is red.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getPlayStrategy--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlayStrategy</h4>
<pre>public&nbsp;<a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;getPlayStrategy()</pre>
<div class="block">Returns the <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> used by the algorithm at the moment.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>current <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a></dd>
</dl>
</li>
</ul>
<a name="setPlayStrategy-towerwarspp.player.PlayStrategy-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPlayStrategy</h4>
<pre>public&nbsp;void&nbsp;setPlayStrategy(<a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;playStrategy)</pre>
<div class="block">Sets the <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> to the passed one.
 Note: The algorithm will dynamically change it's PlayStrategy to <a href="../../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>PlayStrategy.LIGHT</code></a> if it's close to a
 winning position to reduce the bias introduced by the Heavy PlayOut.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>playStrategy</code> - <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> to use from now on</dd>
</dl>
</li>
</ul>
<a name="getTreeSelectionStrategy--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTreeSelectionStrategy</h4>
<pre>public&nbsp;<a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a>&nbsp;getTreeSelectionStrategy()</pre>
<div class="block">Return the current <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> employed by the algorithm when deciding on it's next move.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>current tree selection strategy</dd>
</dl>
</li>
</ul>
<a name="setTreeSelectionStrategy-towerwarspp.player.mcts.TreeSelectionStrategy-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTreeSelectionStrategy</h4>
<pre>public&nbsp;void&nbsp;setTreeSelectionStrategy(<a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts">TreeSelectionStrategy</a>&nbsp;treeSelectionStrategy)</pre>
<div class="block">Sets the passed <a href="../../../towerwarspp/player/mcts/TreeSelectionStrategy.html" title="enum in towerwarspp.player.mcts"><code>TreeSelectionStrategy</code></a> to the passed one.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>treeSelectionStrategy</code> - strategy to use from now on.</dd>
</dl>
</li>
</ul>
<a name="getMove--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMove</h4>
<pre>public&nbsp;<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;getMove()</pre>
<div class="block">This method is always called fro outside this Thread. It will set <a href="../../../towerwarspp/player/mcts/Mcts.html#startTime"><code>startTime</code></a> to the current System time.
 Then add a <a href="../../../towerwarspp/player/mcts/Task.html#MOVE_REQUESTED"><code>Task.MOVE_REQUESTED</code></a> to the queue and set the callers Thread to wait(). If the Thread is woke up, it
 will return the Move currently store in <a href="../../../towerwarspp/player/mcts/Mcts.html#currentBestMove"><code>currentBestMove</code></a>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <a href="../../../towerwarspp/player/mcts/Mcts.html#currentBestMove"><code>currentBestMove</code></a> after the sspecified <a href="../../../towerwarspp/player/mcts/Mcts.html#timePerMove"><code>timePerMove</code></a></dd>
</dl>
</li>
</ul>
<a name="setInit-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setInit</h4>
<pre>public&nbsp;void&nbsp;setInit(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">Method is called from other Thread.
 Sets the <a href="../../../towerwarspp/player/mcts/Mcts.html#newBoard"><code>newBoard</code></a> variable to the passed Board and add a <a href="../../../towerwarspp/player/mcts/Task.html#INIT"><code>Task.INIT</code></a> to the queue to signal Thread containing
 the <a href="../../../towerwarspp/player/mcts/Mcts.html#run--"><code>run()</code></a> method that a new board is available and a new tree should be constructed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - that will be used as new initial game state</dd>
</dl>
</li>
</ul>
<a name="feedEnemyMove-towerwarspp.preset.Move-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>feedEnemyMove</h4>
<pre>public&nbsp;void&nbsp;feedEnemyMove(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</pre>
<div class="block">Use to update the state of the tree after the enemy has made a move.
 If <a href="../../../towerwarspp/player/mcts/Mcts.html#fairPlay"><code>fairPlay</code></a> is set to true, <a href="../../../towerwarspp/player/mcts/Mcts.html#timePerMove"><code>timePerMove</code></a> is set to the time the enemy spend deciding on his move.
 <a href="../../../towerwarspp/player/mcts/Mcts.html#enemyMove"><code>enemyMove</code></a> is set to the passed Move and a <a href="../../../towerwarspp/player/mcts/Task.html#MOVE_RECEIVED"><code>Task.MOVE_RECEIVED</code></a> is added to the queue, to notify the algorithm
 Thread that the enemy has made a move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - that the enemy made.</dd>
</dl>
</li>
</ul>
<a name="bestMove--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bestMove</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;bestMove()</pre>
<div class="block">This method is called if the Thread has used it's available timePerMove to decide on the final Move that should
 be played. Depending on the setting of <a href="../../../towerwarspp/player/mcts/Mcts.html#treeSelectionStrategy"><code>treeSelectionStrategy</code></a> either the Move with the highest win ratio
 represented by the Node returned by calling <a href="../../../towerwarspp/player/mcts/Node.html#maxChild--"><code>Node.maxChild()</code></a> on the root, is selected or the move that has been
 played the most often represented by the Node returned from <a href="../../../towerwarspp/player/mcts/Node.html#robustChild--"><code>Node.robustChild()</code></a>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Move of the best root child Node depending on the Tree Selection strategy</dd>
</dl>
</li>
</ul>
<a name="addTask-towerwarspp.player.mcts.Task-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addTask</h4>
<pre>private&nbsp;void&nbsp;addTask(<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&nbsp;task)</pre>
<div class="block">Adds a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> the the task queue</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>task</code> - task to add to end of queue</dd>
</dl>
</li>
</ul>
<a name="removeTask--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeTask</h4>
<pre>private&nbsp;void&nbsp;removeTask()</pre>
<div class="block">Removes a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> from the task queue</div>
</li>
</ul>
<a name="pollTask--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pollTask</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&nbsp;pollTask()</pre>
<div class="block">Returns and removes a <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a> from the Tsk queue</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>task from head of queue</dd>
</dl>
</li>
</ul>
<a name="peekTask--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>peekTask</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts">Task</a>&nbsp;peekTask()</pre>
<div class="block">Returns but does not remove the Task at the head of the queue</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>head of the <a href="../../../towerwarspp/player/mcts/Mcts.html#tasks"><code>tasks</code></a> queue</dd>
</dl>
</li>
</ul>
<a name="init--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>init</h4>
<pre>private&nbsp;void&nbsp;init()</pre>
<div class="block">Reinitialize this Mcts object by setting the board to the new Board passed via <a href="../../../towerwarspp/player/mcts/Mcts.html#newBoard"><code>newBoard</code></a>.
 A new <a href="../../../towerwarspp/player/mcts/Mcts.html#root"><code>root</code></a> is constructed and <a href="../../../towerwarspp/player/mcts/Mcts.html#rootPlayout--"><code>rootPlayout()</code></a> is called to fully expand the root and do a
 playout on all the new children.</div>
</li>
</ul>
<a name="wakeUp--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>wakeUp</h4>
<pre>private&nbsp;void&nbsp;wakeUp()</pre>
<div class="block">Wakes up the Thread that has requested a Move by calling notify().</div>
</li>
</ul>
<a name="checkPlayoutStrategy-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkPlayoutStrategy</h4>
<pre>private&nbsp;void&nbsp;checkPlayoutStrategy(double&nbsp;weight)</pre>
<div class="block">Decides if to update the current <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a> depending on the weight of the last played Move.
 If the weight is above 0.98 the play strategy is changed to a <a href="../../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>PlayStrategy.LIGHT</code></a> playout to reduce
 the bias introduced by the heavy playout strategy.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>weight</code> - weight of last selected child Node</dd>
</dl>
</li>
</ul>
<a name="updateRoot-towerwarspp.preset.Move-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateRoot</h4>
<pre>private&nbsp;void&nbsp;updateRoot(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</pre>
<div class="block">Used to update the <a href="../../../towerwarspp/player/mcts/Mcts.html#root"><code>root</code></a> of the tree after the enemy has made a move. First the passed Move is compared
 against the moves of the child <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts"><code>Node</code></a>'s of the current root. If a match is found, the child is set as new root,
 the move is played on the <a href="../../../towerwarspp/player/mcts/Mcts.html#board"><code>board</code></a> and a <a href="../../../towerwarspp/player/mcts/Mcts.html#rootPlayout--"><code>rootPlayout()</code></a> is executed.
 Also memory is made available to be cleared up by the Garbage Collector by deleting references to the now unused
 subtree.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - the enemy move.</dd>
</dl>
</li>
</ul>
<a name="updateRoot-towerwarspp.player.mcts.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateRoot</h4>
<pre>private&nbsp;void&nbsp;updateRoot(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;node)</pre>
<div class="block">Used to update the root of the tree after the algorithm has decided on a move to play. First the <a href="../../../towerwarspp/player/mcts/Mcts.html#root"><code>root</code></a> is
 set to the passed Node, the move represented by the new root is played on the board and depending on the state of
 the game a <a href="../../../towerwarspp/player/mcts/Mcts.html#rootPlayout--"><code>rootPlayout()</code></a> is executed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - node to set as new root</dd>
</dl>
</li>
</ul>
<a name="rootPlayout--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rootPlayout</h4>
<pre>private&nbsp;void&nbsp;rootPlayout()</pre>
<div class="block">This method should always be called after a new root has been set.
 First <a href="../../../towerwarspp/player/mcts/Node.html#fullExpand-towerwarspp.board.Board-"><code>Node.fullExpand(Board)</code></a> is called on the root to fully expand it and get a List containing all
 so far unexplored children of that Node. Then for every unexplored child a playout with the current <a href="../../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player"><code>PlayStrategy</code></a>
 is executed and the result backpropagated up the tree.</div>
</li>
</ul>
<a name="freeAncestorMemory-towerwarspp.player.mcts.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>freeAncestorMemory</h4>
<pre>private&nbsp;void&nbsp;freeAncestorMemory(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;node)</pre>
<div class="block">Method to make a part of the search tree that is of no use anymore available to be cleared by the Garbage Collector
 by iteratively setting the parent references of all the ancestors of the passed Node to null.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - node to start freeing memory from</dd>
</dl>
</li>
</ul>
<a name="run--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>run</h4>
<pre>public&nbsp;void&nbsp;run()</pre>
<div class="block">Main loop of the Monte Carlo tree search. As long as the Game is running the run method is executed.
 Each iteration it is checked if the <a href="../../../towerwarspp/player/mcts/Mcts.html#tasks"><code>tasks</code></a> queue contains any submitted <a href="../../../towerwarspp/player/mcts/Task.html" title="enum in towerwarspp.player.mcts"><code>Task</code></a>'s, if  that is the case
 <a href="../../../towerwarspp/player/mcts/Mcts.html#peekTask--"><code>peekTask()</code></a> is called to get the task at the front of the queue. In the case of <a href="../../../towerwarspp/player/mcts/Task.html#INIT"><code>Task.INIT</code></a> and
 <a href="../../../towerwarspp/player/mcts/Task.html#MOVE_RECEIVED"><code>Task.MOVE_RECEIVED</code></a> the tasks will be executed by calling the necessary functions and the completed task
 is deleted from the queue by calling <a href="../../../towerwarspp/player/mcts/Mcts.html#removeTask--"><code>removeTask()</code></a>. If the Task at the front of the queue is
 <a href="../../../towerwarspp/player/mcts/Task.html#MOVE_REQUESTED"><code>Task.MOVE_REQUESTED</code></a> it will be ignored as long the algorithm <a href="../../../towerwarspp/player/mcts/Mcts.html#timePerMove"><code>timePerMove</code></a> hasn't run out or
 the root of the tree has a terminal
 causing the board and tree to be reinitialized, a best Move to be chosen or the root to be reset respectively.

 If none of the flags is set and the board status is OK <a href="../../../towerwarspp/player/mcts/Mcts.html#parallelizationFactor"><code>parallelizationFactor</code></a> many <a href="../../../towerwarspp/player/mcts/UpdateTree.html" title="class in towerwarspp.player.mcts"><code>UpdateTree</code></a>
 instances will be created per iteration and submitted to the <a href="../../../towerwarspp/player/mcts/Mcts.html#updatePool"><code>updatePool</code></a>. After submitting those
 runnable's it's waited until all returned <a href="../../../towerwarspp/player/mcts/Mcts.html#futures"><code>futures</code></a> are done. Then the loop is executed again.

 In case the status of the Game is != OK the Thread will sleep for some amount of time per loop iteration to not
 waste processing power.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>run</code>&nbsp;in interface&nbsp;<code>java.lang.Runnable</code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Mcts.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?towerwarspp/player/mcts/Mcts.html" target="_top">Frames</a></li>
<li><a href="Mcts.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
